//
//  Copyright (c) 2005, Scott R. Turner
//  Released under the GPL license
//  http://www.gnu.org/copyleft/gpl.html
//
//  Mon May 30 21:45:51 2005 -- Scott R. Turner
//
//  Functions to run the Platypus toolbar.
//

//
//  platypus_handle_toolbar
//  Mon May 30 21:46:34 2005 -- Scott R. Turner
//
//  When a button is clicked, turn its check on if appropriate and
//  uncheck any other checked button.
//
function platypus_handle_toolbar(event) {
    
    var doc = platypus_find_active_document(getBrowser().selectedBrowser.contentWindow.document);
    //
    //  If Platypus isn't started, start it up!
    //
    if (!doc || !doc.platypus_started) {
	var alldocs = platypus_find_all_documents(getBrowser().selectedBrowser.contentWindow.document);
	if (alldocs.length > 1) {
	    alert("This web page contains frames.  Start Platypus in a frame by right-clicking in the frame and selecting 'Platypus!' from the context menu.");
	    return;
	} else {
	    doc = getBrowser().selectedBrowser.contentWindow.document;
	    start_platypus_on_doc(doc);
	};
    };

    Dump("Started doc is "+doc.location);
    //
    //  Do whatever is necessary.   
    //
    platypus_do_toolbar_button(event);
    //
    //  If this button isn't autoCheck, then leave everything
    //
    var focused = event.currentTarget;
    var tb = focused.parentNode;
    for(var i=0; i < tb.childNodes.length; i++) {
	tb.childNodes.item(i).checked = false;
    };
    //
    //  Now check this one, if appropriate.  If Platypus is no longer
    //  running, don't check anything.
    //
    if (doc.platypus_started &&
	focused.autoCheck == true) focused.checked = true;
};

//
//  platypus_help
//  Tue May 31 22:59:24 2005 -- Scott R. Turner
//
//  Special function to handle Platypus Help so that you can pop it up
//  without affecting anything else.
//
function platypus_help_button(evt) {
    var doc = getBrowser().selectedBrowser.contentWindow.document;
    platypus_help(doc, null);
};

//
//  platypus_stop_toolbar
//  Wed Jun 01 10:30:25 2005 -- Scott R. Turner
//
//  Go through and turn off all Platypus toolbar buttons.
//
function platypus_stop_toolbar() {
  var pref = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService).
      getBranch("extensions.platypus.");
  var doc = document;
  //
  //  For some reason (probably obvious to people who understand Xpath)
  //  //toolbarbutton[contains(@id,'platypus')] does not return the
  //  expected list of toolbarbuttons.
  //
  var allButtons = document.evaluate("//*[contains(@id,'platypus')]",
				 document, null,
				 XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE,
				 null);
  for (var i = 0; i < allButtons.snapshotLength; i++) {
      var thisButton = allButtons.snapshotItem(i);
      //
      //  Hide the toolbar
      //
      if (thisButton.tagName == "toolbar" &&
	  pref.getPrefType("autoHideToolbar") == pref.PREF_BOOL &&
	  pref.getBoolPref("autoHideToolbar") == true) {
	  thisButton.collapsed = true;
      };
      //
      //  Uncheck all the buttons
      //
      if (thisButton.tagName == "toolbarbutton") {
	  thisButton.checked = false;
      };
  }  

};

//
//  platypus_start_toolbar
//  Wed Jun 01 20:25:09 2005 -- Scott R. Turner
//
//  Make the toolbar visible and "check" the appropriate button.
//
function platypus_start_toolbar() {
  var pref = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService).
      getBranch("extensions.platypus.");
  var doc = document;
  var doc2 = getBrowser().selectedBrowser.contentWindow.document;
  //
  //  For some reason (probably obvious to people who understand Xpath)
  //  //toolbarbutton[contains(@id,'platypus')] does not return the
  //  expected list of toolbarbuttons.
  //
  var allButtons = document.evaluate("//*[contains(@id,'platypus')]",
				 document, null,
				 XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE,
				 null);
  for (var i = 0; i < allButtons.snapshotLength; i++) {
      var thisButton = allButtons.snapshotItem(i);
      //
      //  Expose the toolbar
      //
      if (thisButton.tagName == "toolbar" &&
	  pref.getPrefType("autoHideToolbar") == pref.PREF_BOOL &&
	  pref.getBoolPref("autoHideToolbar") == true) {
	  thisButton.collapsed = false;
      };
      //
      //  This is a little hairy, but we're looking for the
      //  button whose name matches the platypus_default_func_name
      //
      if (thisButton.tagName == "toolbarbutton" &&
	  thisButton.id == doc2.platypus_default_func_name ) {
	  thisButton.checked = true;
      };
  }

};
